(*complex_arith.ml*)
#use "complex.ml"

(*arithmetic operations on complex numbers*)
(*opr is one of "add", "sub", "mul", and "div"*)
let rec complex_arith opr = 
    let add a b = (*TODO: implement add in rectangular form: using real and imag*)


    let sub a b = (*TODO: implement sub in rectangular form: using real and imag*)


    let mul a b = (*TODO: implement mul in polar form: using mag and ang*)


    let div a b = (*TODO: implement div in polar form: using mag and ang*)


    (*TODO: return add, sub, mul or div depending on opr*)        


(*test*)
let equ a b =
    let eps = 1e-10 in
    let abs x = if x < 0. then -. x else x in
    abs (a -. b) < eps

let test_arith a b =
    Printf.printf "testing arith...\n";
    let ( + ) = complex_arith "add" in
    let ( - ) = complex_arith "sub" in
    let ( * ) = complex_arith "mul" in
    let ( / ) = complex_arith "div" in
    let ( == ) = equ in

    a + b |> fun c -> assert (c "real" == 3.  && c "imag" == 4.);
    a - b |> fun c -> assert (c "real" == 1.  && c "imag" == 2.);
    a * b |> fun c -> assert (c "real" == -1. && c "imag" == 5.);
    a / b |> fun c -> assert (c "real" == 2.5 && c "imag" == 0.5);
    Printf.printf "success.\n"

let test_arith_complex () = 
    let a = complex 2. 3. in
    let b = complex 1. 1. in
    test_arith a b

let test_arith_polar () = 
    let a = complex 2. 3. in
    let b = complex 1. 1. in
    let c = polar (a "mag") (a "ang") in
    let d = polar (b "mag") (b "ang") in
    test_arith c d

(*
let _ = test_arith_complex ()    
let _ = test_arith_polar ()    
*)